__gnu_cxx::stdio_sync_filebuf< _CharT, _Traits > Class Template Reference
I/O

`#include <stdio_sync_filebuf.h>`

Inheritance diagram for __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >:
[legend]

## Public Types

typedef _CharT | char_type
typedef traits_type::int_type | int_type
typedef traits_type::off_type | off_type
typedef traits_type::pos_type | pos_type
typedef _Traits | traits_type

## Public Member Functions

| stdio_sync_filebuf (std::__c_file *__f)
| stdio_sync_filebuf (stdio_sync_filebuf &&__fb) noexcept
std::__c_file * | file ()
locale | getloc () const
streamsize | in_avail ()
stdio_sync_filebuf & | operator= (stdio_sync_filebuf &&__fb) noexcept
locale | pubimbue (const locale &__loc)
int_type | sbumpc ()
int_type | sgetc ()
streamsize | sgetn (char_type *__s, streamsize __n)
int_type | snextc ()
int_type | sputbackc (char_type __c)
int_type | sputc (char_type __c)
streamsize | sputn (const char_type *__s, streamsize __n)
int_type | sungetc ()
void | swap (stdio_sync_filebuf &__fb)
basic_streambuf * | pubsetbuf (char_type *__s, streamsize __n)
pos_type | pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
pos_type | pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
int | pubsync ()

## Protected Member Functions

void | __safe_gbump (streamsize __n)
void | __safe_pbump (streamsize __n)
void | gbump (int __n)
virtual void | imbue (const locale &__loc)
virtual int_type | overflow (int_type __c=traits_type::eof())
virtual int_type | pbackfail (int_type __c=traits_type::eof())
void | pbump (int __n)
virtual std::streampos | seekoff (std::streamoff __off, std::ios_base::seekdir __dir, std::ios_base::openmode=std::ios_base::in|std::ios_base::out)
virtual pos_type | seekoff (off_type, ios_base::seekdir, ios_base::openmode=ios_base::in|ios_base::out)
virtual std::streampos | seekpos (std::streampos __pos, std::ios_base::openmode __mode=std::ios_base::in|std::ios_base::out)
virtual pos_type | seekpos (pos_type, ios_base::openmode=ios_base::in|ios_base::out)
virtual basic_streambuf< char_type, _Traits > * | setbuf (char_type *, streamsize)
void | setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
void | setp (char_type *__pbeg, char_type *__pend)
virtual streamsize | showmanyc ()
void | swap (basic_streambuf &__sb)
virtual int | sync ()
stdio_sync_filebuf< wchar_t >::int_type | syncgetc ()
stdio_sync_filebuf< char >::int_type | syncgetc ()
int_type | syncgetc ()
stdio_sync_filebuf< wchar_t >::int_type | syncputc (int_type __c)
stdio_sync_filebuf< char >::int_type | syncputc (int_type __c)
int_type | syncputc (int_type __c)
stdio_sync_filebuf< wchar_t >::int_type | syncungetc (int_type __c)
stdio_sync_filebuf< char >::int_type | syncungetc (int_type __c)
int_type | syncungetc (int_type __c)
virtual int_type | uflow ()
virtual int_type | underflow ()
std::streamsize | xsgetn (char *__s, std::streamsize __n)
virtual std::streamsize | xsgetn (char_type *__s, std::streamsize __n)
std::streamsize | xsgetn (wchar_t *__s, std::streamsize __n)
virtual streamsize | xsgetn (char_type *__s, streamsize __n)
std::streamsize | xsputn (const char *__s, std::streamsize __n)
virtual std::streamsize | xsputn (const char_type *__s, std::streamsize __n)
std::streamsize | xsputn (const wchar_t *__s, std::streamsize __n)
virtual streamsize | xsputn (const char_type *__s, streamsize __n)
char_type * | eback () const
char_type * | gptr () const
char_type * | egptr () const
char_type * | pbase () const
char_type * | pptr () const
char_type * | epptr () const

## Protected Attributes

locale | _M_buf_locale
char_type * | _M_in_beg
char_type * | _M_in_cur
char_type * | _M_in_end
char_type * | _M_out_beg
char_type * | _M_out_cur
char_type * | _M_out_end

## Detailed Description

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>
class __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >

Provides a layer of compatibility for C.

This GNU extension provides extensions for working with standard C FILE*'s. It must be instantiated by the user with the type of character used in the file stream, e.g., stdio_filebuf<char>.

Definition at line 58 of file stdio_sync_filebuf.h.

## Member Typedef Documentation

## char_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef _CharT __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::char_type

Definition at line 62 of file stdio_sync_filebuf.h.

## int_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::int_type

Definition at line 64 of file stdio_sync_filebuf.h.

## off_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::off_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::off_type

Definition at line 66 of file stdio_sync_filebuf.h.

## pos_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::pos_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::pos_type

Definition at line 65 of file stdio_sync_filebuf.h.

## traits_type

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef _Traits __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::traits_type

Definition at line 63 of file stdio_sync_filebuf.h.

## Constructor & Destructor Documentation

## stdio_sync_filebuf() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

__gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::stdio_sync_filebuf | ( | std::__c_file * | __f | ) |

inline explicit

Definition at line 80 of file stdio_sync_filebuf.h.

## stdio_sync_filebuf() [2/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

__gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::stdio_sync_filebuf | ( | stdio_sync_filebuf< _CharT, _Traits > && | __fb | ) |

inline noexcept

Definition at line 85 of file stdio_sync_filebuf.h.

## Member Function Documentation

## __safe_gbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::__safe_gbump | ( | streamsize | __n | ) |

inline protected inherited

Definition at line 807 of file streambuf.

## __safe_pbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::__safe_pbump | ( | streamsize | __n | ) |

inline protected inherited

Definition at line 810 of file streambuf.

## eback()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::eback | ( |  | ) | const

inline protected inherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 489 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## egptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::egptr | ( |  | ) | const

inline protected inherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 499 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_streambuf< char_type, traits_type >::in_avail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sgetc(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::wbuffer_convert< _Codecvt, _Elem, _Tr >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and xsgetn().

## epptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::epptr | ( |  | ) | const

inline protected inherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 547 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sputc(), std::basic_filebuf< _CharT, _Traits >::xsputn(), and xsputn().

## file()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

std::__c_file * __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::file | ( |  | ) |

inline

Returns
  The underlying FILE*.

This function can be used to access the underlying C file pointer. Note that there is no way for the library to track what you do with the file, so be careful.

Definition at line 119 of file stdio_sync_filebuf.h.

## gbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::gbump | ( | int | __n | ) |

inline protected inherited

Moving the read position.

Parameters

  __n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 509 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_streambuf< char_type, traits_type >::uflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## getloc()

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::getloc | ( |  | ) | const

inline inherited

Locale access.

Returns
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 233 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubimbue().

## gptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::gptr | ( |  | ) | const

inline protected inherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 496 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_streambuf< char_type, traits_type >::in_avail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_streambuf< char_type, traits_type >::sgetc(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_streambuf< char_type, traits_type >::uflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::wbuffer_convert< _Codecvt, _Elem, _Tr >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and xsgetn().

## imbue()

template<typename _CharT, typename _Traits>

virtual void std::basic_streambuf< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) |

inline protected virtual inherited

Changes translations.

Parameters

  __loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained.

Note
  Base class version does nothing.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< wchar_t >.

Definition at line 588 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubimbue().

## in_avail()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::in_avail | ( |  | ) |

inline inherited

Looking ahead into the stream.

Returns
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 291 of file streambuf.

## operator=()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

stdio_sync_filebuf & __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::operator= | ( | stdio_sync_filebuf< _CharT, _Traits > && | __fb | ) |

inline noexcept

Definition at line 94 of file stdio_sync_filebuf.h.

## overflow()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::overflow | ( | int_type | __c = traits_type::eof() | ) |

inline protected virtual

Consumes data from the buffer; writes to the controlled sequence.

Parameters

  __c | An additional character to consume.

Returns
  eof() to indicate failure, something else (usually __c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is consumed, with some effect on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if __c is not `eof()`.

For a formal definition of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 172 of file stdio_sync_filebuf.h.

## pbackfail()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::pbackfail | ( | int_type | __c = traits_type::eof() | ) |

inline protected virtual

Tries to back up the input sequence.

Parameters

  __c | The character to be inserted back into the sequence.

Returns
  eof() on failure, some other value on success

Postcondition
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 147 of file stdio_sync_filebuf.h.

## pbase()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::pbase | ( |  | ) | const

inline protected inherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 541 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::str(), std::basic_filebuf< _CharT, _Traits >::sync(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## pbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::pbump | ( | int | __n | ) |

inline protected inherited

Moving the write position.

Parameters

  __n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 557 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), and std::basic_streambuf< char_type, traits_type >::sputc().

## pptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::pptr | ( |  | ) | const

inline protected inherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 544 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_streambuf< char_type, traits_type >::sputc(), std::basic_filebuf< _CharT, _Traits >::sync(), std::basic_filebuf< _CharT, _Traits >::xsputn(), and xsputn().

## pubimbue()

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::pubimbue | ( | const locale & | __loc | ) |

inline inherited

Entry point for imbue().

Parameters

  __loc | The new locale.

Returns
  The previous locale.

Calls the derived imbue(__loc).

Definition at line 216 of file streambuf.

## pubseekoff()

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )

inline inherited

Alters the stream position.

Parameters

  __off | Offset.
  __way | Value for ios_base::seekdir.
  __mode | Value for ios_base::openmode.

Calls virtual seekoff function.

Definition at line 258 of file streambuf.

## pubseekpos()

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekpos | ( | pos_type | __sp,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )

inline inherited

Alters the stream position.

Parameters

  __sp | Position
  __mode | Value for ios_base::openmode.

Calls virtual seekpos function.

Definition at line 270 of file streambuf.

## pubsetbuf()

template<typename _CharT, typename _Traits>

basic_streambuf * std::basic_streambuf< _CharT, _Traits >::pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n )

inline inherited

Entry points for derived buffer functions.

The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 246 of file streambuf.

## pubsync()

template<typename _CharT, typename _Traits>

int std::basic_streambuf< _CharT, _Traits >::pubsync | ( |  | ) |

inline inherited

Calls virtual sync function.

Definition at line 278 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::sync().

## sbumpc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sbumpc | ( |  | ) |

inline inherited

Getting the next character.

Returns
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 323 of file streambuf.

Referenced by std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_streambuf< char_type, traits_type >::snextc(), and std::basic_iostream< char_type, traits_type >::sync().

## seekoff() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual std::streampos __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::seekoff | ( | std::streamoff | __off,
|  | std::ios_base::seekdir | __dir,
|  | std::ios_base::openmode | = std::ios_base::in | std::ios_base::out )

inline protected virtual

Definition at line 195 of file stdio_sync_filebuf.h.

## seekoff() [2/2]

template<typename _CharT, typename _Traits>

virtual pos_type std::basic_streambuf< _CharT, _Traits >::seekoff | ( | off_type | ,
|  | ios_base::seekdir | ,
|  | ios_base::openmode | = ios_base::in | ios_base::out )

inline protected virtual inherited

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< char >, std::basic_filebuf< char_type, traits_type >, std::basic_filebuf< wchar_t >, std::basic_stringbuf< _CharT, _Traits, _Alloc >, std::basic_stringbuf< char >, and std::basic_stringbuf< wchar_t >.

Definition at line 614 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubseekoff().

## seekpos() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual std::streampos __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::seekpos | ( | std::streampos | __pos,
|  | std::ios_base::openmode | __mode = std::ios_base::in | std::ios_base::out )

inline protected virtual

Definition at line 217 of file stdio_sync_filebuf.h.

## seekpos() [2/2]

template<typename _CharT, typename _Traits>

virtual pos_type std::basic_streambuf< _CharT, _Traits >::seekpos | ( | pos_type | ,
|  | ios_base::openmode | = ios_base::in | ios_base::out )

inline protected virtual inherited

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< char >, std::basic_filebuf< char_type, traits_type >, std::basic_filebuf< wchar_t >, std::basic_stringbuf< _CharT, _Traits, _Alloc >, std::basic_stringbuf< char >, and std::basic_stringbuf< wchar_t >.

Definition at line 626 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubseekpos().

## setbuf()

template<typename _CharT, typename _Traits>

virtual basic_streambuf< char_type, _Traits > * std::basic_streambuf< _CharT, _Traits >::setbuf | ( | char_type * | ,
|  | streamsize | )

inline protected virtual inherited

Manipulates the buffer.

Each derived class provides its own appropriate behavior. See the next-to-last paragraph of https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html#io.streambuf.buffering for more on this function.

Note
  Base class version does nothing, returns `this`.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, std::basic_filebuf< char_type, traits_type >, std::basic_stringbuf< _CharT, _Traits, _Alloc >, and std::basic_stringbuf< char >.

Definition at line 603 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubsetbuf().

## setg()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend )

inline protected inherited

Setting the three read area pointers.

Parameters

  __gbeg | A pointer.
  __gnext | A pointer.
  __gend | A pointer.

Postcondition
  __gbeg == `eback()`, __gnext == `gptr()`, and __gend == `egptr()`

Definition at line 521 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::wbuffer_convert(), std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## setp()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend )

inline protected inherited

Setting the three write area pointers.

Parameters

  __pbeg | A pointer.
  __pend | A pointer.

Postcondition
  __pbeg == `pbase()`, __pbeg == `pptr()`, and __pend == `epptr()`

Definition at line 567 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::wbuffer_convert(), and std::basic_filebuf< char_type, traits_type >::_M_set_buffer().

## sgetc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sgetc | ( |  | ) |

inline inherited

Getting the next character.

Returns
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 345 of file streambuf.

Referenced by std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_iostream< char_type, traits_type >::readsome(), and std::basic_streambuf< char_type, traits_type >::snextc().

## sgetn()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sgetn | ( | char_type * | __s,
|  | streamsize | __n )

inline inherited

Entry point for xsgetn.

Parameters

  __s | A buffer area.
  __n | A count.

Returns xsgetn(__s,__n). The effect is to fill __s[0] through __s[__n-1] with characters from the input sequence, if possible.

Definition at line 364 of file streambuf.

## showmanyc()

template<typename _CharT, typename _Traits>

virtual streamsize std::basic_streambuf< _CharT, _Traits >::showmanyc | ( |  | ) |

inline protected virtual inherited

Investigating the data available.

Returns
  An estimate of the number of characters available in the input sequence, or -1.

If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail. [27.5.2.4.3]/1

Note
  Base class version does nothing, returns zero.
  The standard adds that the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return immediately.
  The standard adds that the morphemes of `showmanyc` are es-how-many-see, not show-manic.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, std::basic_filebuf< char_type, traits_type >, std::basic_filebuf< wchar_t >, std::basic_stringbuf< _CharT, _Traits, _Alloc >, std::basic_stringbuf< char >, and std::basic_stringbuf< wchar_t >.

Definition at line 661 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::in_avail().

## snextc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::snextc | ( |  | ) |

inline inherited

Getting the next character.

Returns
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 305 of file streambuf.

Referenced by std::basic_iostream< char_type, traits_type >::get(), std::basic_iostream< char_type, traits_type >::get(), std::basic_iostream< char_type, traits_type >::ignore(), and std::basic_iostream< char_type, traits_type >::putback().

## sputbackc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputbackc | ( | char_type | __c | ) |

inline inherited

Pushing characters back into the input stream.

Parameters

  __c | The character to push back.

Returns
  The previous character, if possible.

Similar to sungetc(), but __c is pushed onto the stream instead of the previous character. If successful, the next character fetched from the input stream will be __c.

Definition at line 379 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::putback().

## sputc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputc | ( | char_type | __c | ) |

inline inherited

Entry point for all single-character output functions.

Parameters

  __c | A character to output.

Returns
  __c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores __c in that position, increments the position, and returns `traits::to_int_type(__c)`. If a write position is not available, returns `overflow(__c)`.

Definition at line 431 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::overflow().

## sputn()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sputn | ( | const char_type * | __s,
|  | streamsize | __n )

inline inherited

Entry point for all single-character output functions.

Parameters

  __s | A buffer read area.
  __n | A count.

One of two public output functions.

Returns xsputn(__s,__n). The effect is to write __s[0] through __s[__n-1] to the output sequence, if possible.

Definition at line 457 of file streambuf.

## sungetc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sungetc | ( |  | ) |

inline inherited

Moving backwards in the input stream.

Returns
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to unget the last character gotten.

Definition at line 404 of file streambuf.

## swap() [1/2]

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

void __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::swap | ( | stdio_sync_filebuf< _CharT, _Traits > & | __fb | ) |

inline

Definition at line 103 of file stdio_sync_filebuf.h.

## swap() [2/2]

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::swap | ( | basic_streambuf< _CharT, _Traits > & | __sb | ) |

inline protected inherited

Definition at line 824 of file streambuf.

## sync()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::sync | ( |  | ) |

inline protected virtual

Synchronizes the buffer arrays with the controlled sequences.

Returns
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of failure.

Note
  Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 191 of file stdio_sync_filebuf.h.

## syncgetc() [1/2]

stdio_sync_filebuf< wchar_t >::int_type __gnu_cxx::stdio_sync_filebuf< wchar_t >::syncgetc | ( |  | ) |

inline protected

Definition at line 258 of file stdio_sync_filebuf.h.

## syncgetc() [2/2]

stdio_sync_filebuf< char >::int_type __gnu_cxx::stdio_sync_filebuf< char >::syncgetc | ( |  | ) |

inline protected

Definition at line 225 of file stdio_sync_filebuf.h.

## syncputc() [1/2]

stdio_sync_filebuf< wchar_t >::int_type __gnu_cxx::stdio_sync_filebuf< wchar_t >::syncputc | ( | int_type | __c | ) |

inline protected

Definition at line 268 of file stdio_sync_filebuf.h.

## syncputc() [2/2]

stdio_sync_filebuf< char >::int_type __gnu_cxx::stdio_sync_filebuf< char >::syncputc | ( | int_type | __c | ) |

inline protected

Definition at line 235 of file stdio_sync_filebuf.h.

## syncungetc() [1/2]

stdio_sync_filebuf< wchar_t >::int_type __gnu_cxx::stdio_sync_filebuf< wchar_t >::syncungetc | ( | int_type | __c | ) |

inline protected

Definition at line 263 of file stdio_sync_filebuf.h.

## syncungetc() [2/2]

stdio_sync_filebuf< char >::int_type __gnu_cxx::stdio_sync_filebuf< char >::syncungetc | ( | int_type | __c | ) |

inline protected

Definition at line 230 of file stdio_sync_filebuf.h.

## uflow()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::uflow | ( |  | ) |

inline protected virtual

Fetches more data from the controlled sequence.

Returns
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 139 of file stdio_sync_filebuf.h.

## underflow()

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::underflow | ( |  | ) |

inline protected virtual

Fetches more data from the controlled sequence.

Returns
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is refilled. In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definition of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 132 of file stdio_sync_filebuf.h.

## xsgetn() [1/3]

std::streamsize __gnu_cxx::stdio_sync_filebuf< char >::xsgetn | ( | char * | __s,
|  | std::streamsize | __n )

inline protected

Definition at line 240 of file stdio_sync_filebuf.h.

## xsgetn() [2/3]

std::streamsize __gnu_cxx::stdio_sync_filebuf< wchar_t >::xsgetn | ( | wchar_t * | __s,
|  | std::streamsize | __n )

inline protected

Definition at line 273 of file stdio_sync_filebuf.h.

## xsgetn() [3/3]

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::xsgetn | ( | char_type * | __s,
|  | streamsize | __n )

protected virtual inherited

Multiple character extraction.

Parameters

  __s | A buffer area.
  __n | Maximum number of characters to assign.

Returns
  The number of characters assigned.

Fills __s[0] through __s[__n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either __n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, and std::basic_filebuf< char_type, traits_type >.

Definition at line 45 of file streambuf.tcc.

References egptr(), gptr(), std::min(), and uflow().

Referenced by std::basic_streambuf< char_type, traits_type >::sgetn().

## xsputn() [1/3]

std::streamsize __gnu_cxx::stdio_sync_filebuf< char >::xsputn | ( | const char * | __s,
|  | std::streamsize | __n )

inline protected

Definition at line 252 of file stdio_sync_filebuf.h.

## xsputn() [2/3]

std::streamsize __gnu_cxx::stdio_sync_filebuf< wchar_t >::xsputn | ( | const wchar_t * | __s,
|  | std::streamsize | __n )

inline protected

Definition at line 295 of file stdio_sync_filebuf.h.

## xsputn() [3/3]

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::xsputn | ( | const char_type * | __s,
|  | streamsize | __n )

protected virtual inherited

Multiple character insertion.

Parameters

  __s | A buffer area.
  __n | Maximum number of characters to write.

Returns
  The number of characters written.

Writes __s[0] through __s[__n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, and std::basic_filebuf< char_type, traits_type >.

Definition at line 79 of file streambuf.tcc.

References epptr(), std::min(), overflow(), and pptr().

Referenced by std::basic_streambuf< char_type, traits_type >::sputn().

## Member Data Documentation

## _M_buf_locale

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::_M_buf_locale

protected inherited

Current locale setting.

Definition at line 199 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::basic_filebuf().

## _M_in_beg

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_beg

protected inherited

Start of get area.

Definition at line 191 of file streambuf.

## _M_in_cur

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_cur

protected inherited

Current read area.

Definition at line 192 of file streambuf.

## _M_in_end

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_end

protected inherited

End of get area.

Definition at line 193 of file streambuf.

## _M_out_beg

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_beg

protected inherited

Start of put area.

Definition at line 194 of file streambuf.

## _M_out_cur

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_cur

protected inherited

Current put area.

Definition at line 195 of file streambuf.

## _M_out_end

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_end

protected inherited

End of put area.

Definition at line 196 of file streambuf.

The documentation for this class was generated from the following file:

- stdio_sync_filebuf.h